package edu.mermet.tp8.fenetres;

import javax.swing.*;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import java.util.*;

public class FenetreCommentFaire extends JDialog {

	JEditorPane jEditorPane;
	HashMap<String, String> textes;
	HashMap<String, String> valToKey;

	public FenetreCommentFaire(Properties prefs) {
		JSplitPane jSplitPane = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT);
		DefaultListModel<String> model = new DefaultListModel<>();
		JList<String> list = new JList<>( model );
		list.addListSelectionListener(new ListListener());
		jEditorPane = new JEditorPane();
		jEditorPane.setEditable(false);
		jEditorPane.setContentType("text/html");

		textes = new HashMap<>();
		valToKey = new HashMap<>();

		double userComp = Double.parseDouble(prefs.getProperty("competence"));

		try {
			ResourceBundle rbTextes = ResourceBundle.getBundle("HowTo.textes");
			rbTextes.getKeys().asIterator().forEachRemaining(k -> {

			});
			ResourceBundle rb = ResourceBundle.getBundle("HowTo.titres");
			Iterator<String> it = rb.getKeys().asIterator();
			it.forEachRemaining(key -> {
				double comp = Double.parseDouble(key.split(":")[1]);
				if(userComp >= comp) {
					model.addElement(rb.getString(key));
				}
				textes.put(key, rbTextes.getString(key.split(":")[0]));
				valToKey.put(rb.getString(key), key);
			});
		}catch(Exception e) {
			e.printStackTrace();
		}



		jSplitPane.setEnabled(true);

		jSplitPane.add(list);
		jSplitPane.add(jEditorPane);
		add(jSplitPane);

		setTitle("Comment faire ?");
		setSize(600, 400);
		setLocationRelativeTo(null);
		setDefaultCloseOperation(JFrame.HIDE_ON_CLOSE);
	}

	private class ListListener implements ListSelectionListener {

		@Override
		public void valueChanged(ListSelectionEvent e) {
			JList<String> l = (JList<String>)e.getSource();
			String selected = l.getSelectedValue();
			jEditorPane.setText("<html>" + textes.get(valToKey.get(selected)) + "</html>");
		}
	}
}
