package edu.mermet.tp8.fenetres;

import edu.mermet.tp8.Application;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.util.ArrayList;
import java.util.Properties;
import static edu.mermet.tp8.Application.menuProps;

public class FenetreConfigurationMenus extends JDialog {

	JButton valider, annuler;
	static final String[] options = new String[]{"Conversion Celsius/Farenheit", "Saisie de texte", "Diaporama", "Boutons"};


	ArrayList<JRadioButton> btnsAuto;
	ArrayList<JRadioButton> btnsAffiche;
	ArrayList<JRadioButton> btnsCache;

	private Properties preferences;
	private  Application app;

	public FenetreConfigurationMenus(Properties preferences, Application app) {
		this.app = app;

		JPanel pnl = new JPanel(new GridLayout(options.length+1, 1));

		this.preferences = preferences;

		btnsAuto = new ArrayList<>();
		btnsAffiche = new ArrayList<>();
		btnsCache = new ArrayList<>();

		for(String s : options) {
			JPanel inner = new JPanel();

			ButtonGroup grp = new ButtonGroup();

			JRadioButton affiche, cache, auto;
			auto = new JRadioButton("Auto");
			auto.setSelected(true);
			affiche = new JRadioButton("Affiché");
			cache = new JRadioButton("Caché");

			btnsAuto.add(auto);
			btnsAffiche.add(affiche);
			btnsCache.add(cache);

			grp.add(auto);
			grp.add(affiche);
			grp.add(cache);

			inner.add(new JLabel(s));
			inner.add(auto);
			inner.add(affiche);
			inner.add(cache);

			pnl.add(inner);
		}

		for(int i = 0; i < menuProps.length; ++i) {
			if(preferences.getProperty(menuProps[i]) == null) continue;
			if(preferences.getProperty(menuProps[i]).equals("affiche")) {
				btnsAffiche.get(i).setSelected(true);
			}else if(preferences.getProperty(menuProps[i]).equals("cache")) {
				btnsCache.get(i).setSelected(true);
			}
		}

		valider = new JButton(new ActionValider(this));
		annuler = new JButton(new ActionAnnuler(this));

		JPanel btns = new JPanel();
		btns.add(valider);
		btns.add(annuler);
		pnl.add(btns);

		add(pnl);
		pack();
		setLocationRelativeTo(null);
		setTitle("Configuration des menus");
		setModal(true);
	}

	private class ActionValider extends AbstractAction {
		FenetreConfigurationMenus fenetre;
		private ActionValider(FenetreConfigurationMenus fenetre) {
			super("Valider");
			this.fenetre = fenetre;
		}
		@Override
		public void actionPerformed(ActionEvent e) {
			for(JRadioButton btn : btnsAuto) {
				if(btn.isSelected()) {
					preferences.setProperty(menuProps[btnsAuto.indexOf(btn)], "auto");
				}
			}
			for(JRadioButton btn : btnsAffiche) {
				if(btn.isSelected()) {
					preferences.setProperty(menuProps[btnsAffiche.indexOf(btn)], "affiche");
				}
			}
			for(JRadioButton btn : btnsCache) {
				if(btn.isSelected()) {
					preferences.setProperty(menuProps[btnsCache.indexOf(btn)], "cache");
				}
			}
			fenetre.setVisible(false);
			app.affichageMenu();
		}
	}

	private class ActionAnnuler extends AbstractAction {
		private FenetreConfigurationMenus fenetre;
		ActionAnnuler(FenetreConfigurationMenus fenetre) {
			super("Annuler");
			this.fenetre = fenetre;
		}
		@Override
		public void actionPerformed(ActionEvent e) {
			for(JRadioButton btn : btnsAuto) {
				btn.setSelected(true);
			}
			fenetre.setVisible(false);
		}
	}

}
