package edu.mermet.tp8.fenetres;

import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.net.MalformedURLException;
import java.net.URL;
import javax.swing.*;
import javax.swing.event.InternalFrameAdapter;
import javax.swing.event.InternalFrameEvent;
import edu.mermet.tp8.Application;

/**
 *
 * @author brunomermet
 */
public class FenetreConversion extends AbstractFenetreInterne {
    private JTextField champCelsius;
    private JTextField champFarenheit;
    private JButton boutonConvertir;
    private Action actionConvertir;

    private JButton helpCelsius, helpFarenheit;

    private boolean celsiusAFocus;
    public FenetreConversion(Action action) {
        super(action,"Conversion celsius/Farenheit");
        this.setSize(new Dimension(100,50));
        this.setLayout(new GridLayout(3,1));
        JPanel ligneCelsius = new JPanel();
        ligneCelsius.setLayout(new FlowLayout(FlowLayout.TRAILING));
        JLabel labCelsius = new JLabel("Celsius :");
        champCelsius = new JTextField(15);
        champCelsius.setToolTipText("Entrez la valeur en degré celsius");
        champCelsius.setComponentPopupMenu(new MenuAide("Valeur en degré celsius", this));
        labCelsius.setLabelFor(champCelsius);
        ligneCelsius.add(labCelsius);
        ligneCelsius.add(champCelsius);
        try {
            ImageIcon imageIcon = new ImageIcon(new URL("https://icons.iconarchive.com/icons/visualpharm/must-have/256/Help-icon.png"));
            Image image = imageIcon.getImage();
            Image resized = image.getScaledInstance(20, 20, Image.SCALE_SMOOTH);
            helpCelsius = new JButton(new ActionAide("Valeur en degré celsius", this));
            helpCelsius.setIcon(new ImageIcon(resized));
            helpCelsius.setBorderPainted(false);
            helpCelsius.setContentAreaFilled(false);
            helpCelsius.setFocusPainted(true);
            helpCelsius.setOpaque(false);
            helpCelsius.setText("");
            ligneCelsius.add(helpCelsius);
        }catch(MalformedURLException e) {
            e.printStackTrace();
        }
        this.add(ligneCelsius);
        celsiusAFocus = true;
        champCelsius.addFocusListener(new EcouteurFocus(true));
        JPanel ligneFarenheit = new JPanel();
        ligneFarenheit.setLayout(new FlowLayout(FlowLayout.TRAILING));
        JLabel labFarenheit = new JLabel("Farenheit :");
        champFarenheit = new JTextField(15);
        champFarenheit.setToolTipText("Entrez la valeur en degré farenheit");
        champFarenheit.setComponentPopupMenu(new MenuAide("Valeur en degré farenheit", this));
        labFarenheit.setLabelFor(champFarenheit);
        ligneFarenheit.add(labFarenheit);
        ligneFarenheit.add(champFarenheit);
        try {
            ImageIcon imageIcon = new ImageIcon(new URL("https://icons.iconarchive.com/icons/visualpharm/must-have/256/Help-icon.png"));
            Image image = imageIcon.getImage();
            Image resized = image.getScaledInstance(20, 20, Image.SCALE_SMOOTH);
            helpFarenheit = new JButton(new ActionAide("Valeur en degré farenheit", this));
            helpFarenheit.setIcon(new ImageIcon(resized));
            helpFarenheit.setBorderPainted(false);
            helpFarenheit.setContentAreaFilled(false);
            helpFarenheit.setFocusPainted(true);
            helpFarenheit.setOpaque(false);
            helpFarenheit.setText("");
            ligneFarenheit.add(helpFarenheit);
        }catch(MalformedURLException e) {
            e.printStackTrace();
        }
        this.add(ligneFarenheit);
        champFarenheit.addFocusListener(new EcouteurFocus(false));
        JPanel ligneValider = new JPanel();
        ligneValider.setLayout(new FlowLayout(FlowLayout.CENTER));
        actionConvertir = new ActionConvertir();
        boutonConvertir = new JButton(actionConvertir);
        ligneValider.add(boutonConvertir);
        this.add(ligneValider);
        
        pack();
        getRootPane().setDefaultButton(boutonConvertir);
    }

    private class MenuAide extends JPopupMenu {
        MenuAide(String message, FenetreConversion fenetre) {
            ActionAide actionAide = new ActionAide(message, fenetre);
            add(actionAide);
        }
    }

    private class EcouteurFocus implements FocusListener {
        private boolean aStocker;

        public EcouteurFocus(boolean b) {
            aStocker = b;
        }

        @Override
        public void focusGained(FocusEvent fe) {
            celsiusAFocus = aStocker;
        }

        @Override
        public void focusLost(FocusEvent fe) {
            return;
        }
    }

    private class ActionAide extends AbstractAction {
        String message;
        FenetreConversion fenetre;
        ActionAide(String message, FenetreConversion fenetre) {
            super("Aide");
            this.message = message;
            this.fenetre = fenetre;
        }
        @Override
        public void actionPerformed(ActionEvent e) {
            JOptionPane.showMessageDialog(fenetre, message, "Aide", JOptionPane.INFORMATION_MESSAGE);
        }
    }

    private class ActionConvertir extends AbstractAction {

        public ActionConvertir() {
            super("Convertir");
        }

        @Override
        public void actionPerformed(ActionEvent ae) {
            double tempCelsius = 0;
            double tempFarenheit = 0;
            if (celsiusAFocus) {
                try {
                    tempCelsius = Double.parseDouble(champCelsius.getText());
                tempFarenheit = 9./5*tempCelsius+32;
                champFarenheit.setText(""+tempFarenheit);
                }
                catch (NumberFormatException nfe) {
                    champFarenheit.setText("Format incorrect");
                }
                }
            else {
                try {
                    tempFarenheit = Double.parseDouble(champFarenheit.getText());
                    tempCelsius = (tempFarenheit - 32) *5./9;
                    champCelsius.setText(""+tempCelsius);
                }
                catch (NumberFormatException nfe) {
                    champCelsius.setText("Format incorrect");
                }
                
            }
        }
    }
    
}
