package edu.mermet.tp8.fenetres;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.util.*;

public class FenetreSuggestion extends JDialog {

	Properties prefs;
	ResourceBundle rb;
	String suggestion;

	public FenetreSuggestion(Properties prefs) {
		this.prefs = prefs;
		rb = ResourceBundle.getBundle("suggestions.suggestions");
		suggestion = trouverSuggestion();
		if(suggestion != null) {
			JLabel lblSugg = new JLabel(rb.getString(suggestion));
			add(lblSugg);

			JPanel boutons = new JPanel();
			JButton btnOk = new JButton(new ActionOk(this));
			JButton btnNePlusVoir = new JButton(new ActionNePlusVoir(this));
			boutons.add(btnOk);
			boutons.add(btnNePlusVoir);

			setLayout(new GridLayout(2, 1));
			add(lblSugg);
			add(boutons, BorderLayout.SOUTH);

			setTitle("Suggestion");
			setLocationRelativeTo(null);
			setDefaultCloseOperation(DISPOSE_ON_CLOSE);
			pack();
			setVisible(true);
		}
	}

	private String trouverSuggestion() {
		Set<String> keys = rb.keySet();
		ArrayList<String> validSugg = new ArrayList<>();
		double userComp = Double.parseDouble(prefs.getProperty("competence"));
		for(String key : keys) {
			if(!key.contains("comp")) {
				double compLevel = Double.parseDouble(rb.getString(key+"_comp"));
				if(log2(compLevel) <= log2(userComp) + 1) {
					validSugg.add(key);
				}
			}
		}
		// Enlever les suggestions cachées (à ne plus afficher)
		validSugg.removeIf(key -> prefs.getProperty(key) != null && prefs.getProperty(key).equals("cacher"));
		if(!validSugg.isEmpty()) {
			return validSugg.get((int)(Math.random() * validSugg.size()));
		}
		return null;
	}

	private static class ActionNePlusVoir extends AbstractAction {
		FenetreSuggestion fenetre;
		ActionNePlusVoir(FenetreSuggestion fenetre) {
			super("Ne plus voir");
			this.fenetre = fenetre;
		}

		@Override
		public void actionPerformed(ActionEvent e) {
			fenetre.prefs.setProperty(fenetre.suggestion, "cacher");
			fenetre.dispose();
		}
	}

	private static class ActionOk extends AbstractAction {
		FenetreSuggestion fenetre;
		ActionOk(FenetreSuggestion fenetre) {
			super("Ok");
			this.fenetre = fenetre;
		}

		@Override
		public void actionPerformed(ActionEvent e) {
			fenetre.dispose();
		}
	}

	public static int log2(double N) {
		return (int)(Math.log(N) / Math.log(2));
	}

}
